#include <bits/stdc++.h>
using namespace std;
int main(){
       ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
int n,k,x;
cin >>n>>k>>x;
int s=n-1;
int sk=s*s-(k-s)*2;
vector <int> rez;
//cout <<sk<<endl;
int sum=0;
while(sk){
for(int j=sqrt(sk);j>=1;j--){

    if(j*j<=sk){
        rez.push_back(j);
        sum+=j;
        sk-=j*j;
        break;
    }
}
}
if(sum>s){
    cout <<-1<<endl;
    return 0;
}
cout <<1<<" ";
int Far=x+1;
for(int i=0;i<rez.size();i++){
        for(int j=0;j<rez[i];j++)
    cout <<Far<<" ";
    Far+=x;
}
cout <<endl;
}